#!/usr/bin/env bash
set -e

version=$1
builtContent="./build"
composerBin='composer'

# Copy project content to temp dir
echo 'Copying project files...'
rm -rf "${builtContent}"
mkdir -p "${builtContent}"
rsync -av * "${builtContent}" \
    --exclude=*docker* \
    --exclude=Dockerfile \
    --include=.htaccess \
    --exclude-from=./.dockerignore
cd "${builtContent}"

# Remove swoole dependency
echo "Removing mezzio-swoole..."
sed -i '/mezzio-swoole/d' composer.json

# Install dependencies
echo "Installing dependencies with $composerBin..."
composerFlags="--optimize-autoloader --no-progress --no-interaction"
${composerBin} install --no-dev --prefer-dist $composerFlags

# Delete development files
echo 'Deleting dev files...'
rm composer.*

# Update shlink version in config
sed -i "s/%SHLINK_VERSION%/${version}/g" config/autoload/app_options.global.php

echo 'Done!'
